package com.qmth.exam.reserve.service.impl;

import java.util.ArrayList;
import java.util.List;

import org.springframework.stereotype.Service;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.qmth.boot.core.exception.StatusException;
import com.qmth.exam.reserve.bean.login.LoginUser;
import com.qmth.exam.reserve.bean.stdapply.CategoryVO;
import com.qmth.exam.reserve.dao.CategoryDao;
import com.qmth.exam.reserve.entity.CategoryEntity;
import com.qmth.exam.reserve.enums.CategoryLevel;
import com.qmth.exam.reserve.enums.Role;
import com.qmth.exam.reserve.service.CategoryService;

@Service
public class CategoryServiceImpl extends ServiceImpl<CategoryDao, CategoryEntity> implements CategoryService {

    @Override
    public List<CategoryVO> listTeaching(LoginUser user) {
        QueryWrapper<CategoryEntity> wrapper = new QueryWrapper<>();
        LambdaQueryWrapper<CategoryEntity> lw = wrapper.lambda();
        List<CategoryEntity> categoryList = new ArrayList<>();
        // 学校管理员
        if (user.getRole().equals(Role.ADMIN)) {
            lw.eq(CategoryEntity::getEnable, Boolean.TRUE);
            lw.eq(CategoryEntity::getLevel, CategoryLevel.THIRD.ordinal() + 1);
            categoryList = this.getBaseMapper().selectList(wrapper);
        } else if (user.getRole().equals(Role.TEACHING)) { // 教学点管理员
            lw.eq(CategoryEntity::getId, user.getCategoryId());
            categoryList = this.getBaseMapper().selectList(wrapper);
        } else {
            throw new StatusException("用户无权限");
        }
        List<CategoryVO> cgList = new ArrayList<>();
        for (CategoryEntity category : categoryList) {
            CategoryVO cg = new CategoryVO();
            cg.setId(category.getId());
            cg.setName(category.getName());
            cgList.add(cg);
        }

        return cgList;
    }

}
