package com.qmth.exam.reserve.service.impl;

import java.util.ArrayList;
import java.util.List;

import org.springframework.stereotype.Service;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.qmth.exam.reserve.bean.stdapply.CategoryVO;
import com.qmth.exam.reserve.dao.ExamSiteDao;
import com.qmth.exam.reserve.entity.ExamSiteEntity;
import com.qmth.exam.reserve.service.ExamSiteService;

@Service
public class ExamSiteServiceImp extends ServiceImpl<ExamSiteDao, ExamSiteEntity> implements ExamSiteService {

    @Override
    public List<CategoryVO> listExamSite(Long teachingId) {
        QueryWrapper<ExamSiteEntity> wrapper = new QueryWrapper<>();
        LambdaQueryWrapper<ExamSiteEntity> lw = wrapper.lambda();
        lw.eq(ExamSiteEntity::getEnable, Boolean.TRUE);
        lw.eq(ExamSiteEntity::getCategoryId, teachingId);
        List<ExamSiteEntity> list = this.baseMapper.selectList(wrapper);
        List<CategoryVO> categoryList = new ArrayList<>();
        for (ExamSiteEntity site : list) {
            CategoryVO vo = new CategoryVO();
            vo.setId(site.getId());
            vo.setName(site.getName());
            categoryList.add(vo);
        }
        return categoryList;
    }

}
